#include "DialogosMain.h"
#include "FrameArquivo.h"

#include <sstream>
#include <iostream>
#include <iomanip>
#include <wx/msgdlg.h>

#include "Principal.h"
#include "Arquivo.h"
#include "Utils.h"

void iniciaCelulas(wxGrid *tabela)
{
    int i,j,lins=tabela->GetNumberRows(),
            cols=tabela->GetNumberCols(),
            nelemT=sizeof(T)/sizeof(REAL);

    for (i=0; i<cols; ++i) {
        for (j=0; j<lins; ++j) {
            /*
            if (i==0) {
                tabela->SetCellRenderer(j, i, new wxGridCellNumberRenderer);
                tabela->SetCellEditor(j, i, new wxGridCellNumberEditor);
            }
            else */ if (i>0 and i<3) {
                tabela->SetCellRenderer(j, i, new wxGridCellAutoWrapStringRenderer);
                tabela->SetCellEditor(j, i, new wxGridCellAutoWrapStringEditor);
            }
            /*
            else {
                if (i < cols-nelemT) {
                    tabela->SetCellRenderer(j, i, new wxGridCellFloatRenderer);
                    tabela->SetCellEditor(j, i, new wxGridCellFloatEditor);
                }
            }

            if (i < cols-nelemT) {
                tabela->SetGridCursor(j,i);
                tabela->EnableCellEditControl();
                tabela->ShowCellEditControl();
            }
            else
            */
             if (i >= cols-nelemT)   tabela->SetReadOnly(j,i);
        }
    }
}

int limpaEntrada(wxGrid *tabela)
{
    int linha;
    tabela->AppendRows(1);
    linha = tabela->GetNumberRows() - 1;

    return linha;
}

void limpaSaida(wxGrid *tabela, int linha)
{
    int i, resCols = sizeof(T)/sizeof(REAL),
        inCols = tabela->GetNumberCols()-resCols;

    for(i=inCols; i < tabela->GetNumberCols(); ++i) {
        tabela->SetCellValue(linha,i,"");
        tabela->SetCellBackgroundColour(linha, i, *wxWHITE);
    }
}

void SetSaida(wxGrid *tabela, int linha)
{
    int i,
        resCols = sizeof(T)/sizeof(REAL),
        inCols = tabela->GetNumberCols()-resCols;
    wxString resStr;

    for (i=0; i < RES; ++i) {
        resStr.Clear();
        resStr << T[i];
        tabela->SetCellValue(linha, i+inCols, resStr);
        tabela->SetCellBackgroundColour(linha, i+inCols, *wxLIGHT_GREY);
    }
}

void SetEntrada(wxGrid *tabela, int linha)
{
    int i;
    wxString Nstr, Xstr, Ystr, DSSstr, DPstr, USstr, E1str, E2str,
             formato =_("%" + wxString::Format("%d",CAMPO) + "." + wxString::Format("%d",PRECISAO)+"f");
    Simulacao reg = simul[linha];

    Nstr << reg.N;
    for (i = 0; i < reg.N; ++i) {
        Xstr << wxString::Format(formato, reg.X[i]) << "\n";
        Ystr << wxString::Format(formato, reg.Y[i]) << "\n";
    }
    DSSstr << reg.DSS;
    DPstr << reg.DP;
    USstr << reg.US;
    E1str << reg.E1;
    E2str << reg.E2;

    tabela->SetCellValue(linha,0, Nstr);
    tabela->SetCellValue(linha,1, Xstr);
    tabela->SetCellValue(linha,2, Ystr);
    tabela->SetCellValue(linha,3, DSSstr);
    tabela->SetCellValue(linha,4, DPstr);
    tabela->SetCellValue(linha,5, USstr);
    tabela->SetCellValue(linha,6, E1str);
    tabela->SetCellValue(linha,7, E2str);
}

wxString valorDefault(wxGrid *tabela, int lin, int col)
{
    wxString val = tabela->GetCellValue(lin,col);

    if (val.IsEmpty())  val = _("0");

    return val;
}

void GetEntrada(wxGrid *tabela, int linha)
{
    int i;
    std::istringstream Xval(tabela->GetCellValue(linha,1).ToStdString()),
                       Yval(tabela->GetCellValue(linha,2).ToStdString());

    valorDefault(tabela,linha,0).ToLong(&simul[linha].N);
    for (i = 0; i < simul[linha].N; ++i) {
        Xval >> simul[linha].X[i];
        Yval >> simul[linha].Y[i];
    }
    valorDefault(tabela,linha,3).ToDouble(&simul[linha].DSS);
    valorDefault(tabela,linha,4).ToDouble(&simul[linha].DP);
    valorDefault(tabela,linha,5).ToDouble(&simul[linha].US);
    valorDefault(tabela,linha,6).ToDouble(&simul[linha].E1);
    valorDefault(tabela,linha,7).ToDouble(&simul[linha].E2);
}

void limpaEntrada(DialogosDialog *dialogo)
{
    dialogo->TextCtrl12->Clear();
    dialogo->TextCtrl6->Clear();  dialogo->TextCtrl7->Clear();
    dialogo->TextCtrl10->Clear(); dialogo->TextCtrl11->Clear();
    dialogo->TextCtrl9->Clear();  dialogo->TextCtrl8->Clear();  dialogo->TextCtrl1->Clear();

    dialogo->TextCtrl6->Disable();  dialogo->TextCtrl7->Disable();
    dialogo->TextCtrl10->Disable(); dialogo->TextCtrl11->Disable();
    dialogo->TextCtrl9->Disable();  dialogo->TextCtrl8->Disable();  dialogo->TextCtrl1->Disable();

    dialogo->TextCtrl12->SetFocus();
}

void limpaSaida(DialogosDialog *dialogo)
{
    dialogo->TextCtrl2->Clear();   dialogo->TextCtrl3->Clear();
    dialogo->TextCtrl4->Clear();   dialogo->TextCtrl5->Clear();
    dialogo->TextCtrl13->Clear();
    dialogo->TextCtrl14->Clear(); dialogo->TextCtrl15->Clear();
}


void SetSaida(DialogosDialog *dialogo)
{
    /*
    saidaFormatada(dialogo->TextCtrl2, T[0], 4, 7);
    saidaFormatada(dialogo->TextCtrl3, T[1], 4, 7);
    saidaFormatada(dialogo->TextCtrl4, T[2], 4, 7);
    saidaFormatada(dialogo->TextCtrl5, T[3], 4, 7);
    saidaFormatada(dialogo->TextCtrl13, T[4], 4, 7);
    */

    *(dialogo->TextCtrl2) << T[0];
    *(dialogo->TextCtrl3) << T[1];
    *(dialogo->TextCtrl4) << T[2];
    *(dialogo->TextCtrl5) << T[3];
    *(dialogo->TextCtrl13) << T[4];
    *(dialogo->TextCtrl14) << T[5];
    *(dialogo->TextCtrl15) << T[6];
}

void SetEntrada(DialogosDialog *dialogo)
{
    int i;
    Simulacao reg = simul[regIdx];

    *(dialogo->TextCtrl12) << reg.N;
    *(dialogo->TextCtrl10) << reg.DSS; *(dialogo->TextCtrl11) << reg.DP;
    *(dialogo->TextCtrl9) << reg.US;
    *(dialogo->TextCtrl8) << reg.E1;   *(dialogo->TextCtrl1) << reg.E2;

    for (i = 0; i < reg.N; ++i) {
        *(dialogo->TextCtrl6) << reg.X[i] << "\n";
        *(dialogo->TextCtrl7) << reg.Y[i] << "\n";
    }

    dialogo->TextCtrl12->Enable();
    dialogo->TextCtrl6->Enable();  dialogo->TextCtrl7->Enable();
    dialogo->TextCtrl10->Enable(); dialogo->TextCtrl11->Enable();
    dialogo->TextCtrl9->Enable();  dialogo->TextCtrl8->Enable();  dialogo->TextCtrl1->Enable();

    dialogo->TextCtrl12->SetFocus();
}

void limpaEntrada(FrameArquivo *dialogo)
{
    dialogo->TextCtrl12->Clear();
    dialogo->TextCtrl6->Clear();  dialogo->TextCtrl7->Clear();
    dialogo->TextCtrl10->Clear(); dialogo->TextCtrl11->Clear();
    dialogo->TextCtrl9->Clear();  dialogo->TextCtrl8->Clear();  dialogo->TextCtrl1->Clear();

    dialogo->TextCtrl6->Disable();  dialogo->TextCtrl7->Disable();
    dialogo->TextCtrl10->Disable(); dialogo->TextCtrl11->Disable();
    dialogo->TextCtrl9->Disable();  dialogo->TextCtrl8->Disable();  dialogo->TextCtrl1->Disable();

    dialogo->TextCtrl12->SetFocus();
}

void limpaSaida(FrameArquivo *dialogo)
{
    dialogo->TextCtrl16->Clear();   dialogo->TextCtrl17->Clear();
    dialogo->TextCtrl18->Clear();   dialogo->TextCtrl19->Clear();
    dialogo->TextCtrl20->Clear();
    dialogo->TextCtrl21->Clear(); dialogo->TextCtrl22->Clear();
}


void SetSaida(FrameArquivo *dialogo)
{
    /*
    saidaFormatada(dialogo->TextCtrl16, T[0], 4, 7);
    saidaFormatada(dialogo->TextCtrl17, T[1], 4, 7);
    saidaFormatada(dialogo->TextCtrl18, T[2], 4, 7);
    saidaFormatada(dialogo->TextCtrl19, T[3], 4, 7);
    saidaFormatada(dialogo->TextCtrl20, T[4], 4, 7);
    saidaFormatada(dialogo->TextCtrl21, T[5], 4, 7);
    saidaFormatada(dialogo->TextCtrl22, T[6], 4, 7);
    */

    *(dialogo->TextCtrl16) << T[0];
    *(dialogo->TextCtrl17) << T[1];
    *(dialogo->TextCtrl18) << T[2];
    *(dialogo->TextCtrl19) << T[3];
    *(dialogo->TextCtrl20) << T[4];
    *(dialogo->TextCtrl21) << T[5];
    *(dialogo->TextCtrl22) << T[6];
}

void SetEntrada(FrameArquivo *dialogo)
{
    int i;
    Simulacao reg = simul[regIdx];

    *(dialogo->TextCtrl12) << reg.N;
    *(dialogo->TextCtrl10) << reg.DSS; *(dialogo->TextCtrl11) << reg.DP;
    *(dialogo->TextCtrl9) << reg.US;
    *(dialogo->TextCtrl8) << reg.E1;   *(dialogo->TextCtrl1) << reg.E2;

    for (i = 0; i < reg.N; ++i) {
        *(dialogo->TextCtrl6) << reg.X[i] << "\n";
        *(dialogo->TextCtrl7) << reg.Y[i] << "\n";
    }

    dialogo->TextCtrl12->Enable();
    dialogo->TextCtrl6->Enable();  dialogo->TextCtrl7->Enable();
    dialogo->TextCtrl10->Enable(); dialogo->TextCtrl11->Enable();
    dialogo->TextCtrl9->Enable();  dialogo->TextCtrl8->Enable();  dialogo->TextCtrl1->Enable();

    dialogo->TextCtrl12->SetFocus();
}



void saidaFormatada(wxTextCtrl *campo, double valor, int precisao, int tamValor)
{
    wxString formato =_("%" + wxString::Format("%d",tamValor) + "." + wxString::Format("%d",precisao)+"f");

    *campo << wxString::Format(formato, valor) << "\n";

    /*
    std::ostream stream(campo);
    stream.precision(precisao);
    stream << setw(tamValor) << valor;
    */
}

void validaCampo (wxTextCtrl *campo, wxTextCtrl *proxCampo, INTG *valor)
{
     if (campo->GetValue().ToLong(valor)) {
        proxCampo->Enable();
        proxCampo->SetFocus();
     }
     else
        wxMessageBox(_("Digite valor numérico !!! "));
}

void validaCampo (wxTextCtrl *campo, wxTextCtrl *proxCampo, REAL *valor)
{
     if (campo->GetValue().ToDouble(valor)) {
        proxCampo->Enable();
        proxCampo->SetFocus();
     }
     else
        wxMessageBox(_("Digite valor numérico !!! "));
}

void procLista(wxTextCtrl *campo, wxTextCtrl *proxCampo, REAL VET[])
{
    int i;
    wxString msg;

    if (campo->GetNumberOfLines() > simul[regIdx].N) {
        for (i=0; i < simul[regIdx].N and campo->GetLineText(i).ToDouble(VET+i+1); ++i);

        if (i < simul[regIdx].N) {
            msg.Printf(_("Digite valor numérico na linha %d"), i+1);
            wxMessageBox(msg);
            campo->Clear();
        }
        else {
            proxCampo->Enable();
            proxCampo->SetFocus();
        }
    }
}

